//+------------------------------------------------------------------+ 
//|                                           Dserg - Supertrend.mq4 | 
//|                                                                  | 
//|                                                                  | 
//+------------------------------------------------------------------+ 
#property copyright "Dserg" 
#property link      "http://www.mql4.com/ru/users/Dserg" 

#property indicator_chart_window 
#property indicator_buffers 7 
#property indicator_color1 SpringGreen 
#property indicator_color2 Red 
#property indicator_color3 DeepSkyBlue 
#property indicator_color4 DeepSkyBlue 
#property indicator_color5 Silver 
#property indicator_color6 SpringGreen 
#property indicator_color7 Red 

#property indicator_width6 2 
#property indicator_width7 2 


double TrendUp[]; 
double TrendDown[]; 
double ChannelUp[]; 
double ChannelDown[];

double ArrowUp[];
double ArrowDn[];
double Arrow[];
extern double coeff = 0.1;
 
int st = 0; 
extern double Dev = 2.0;
extern int DevPeriod = 20;
extern bool constantChannel=true;
extern bool drawChannels = false;
extern datetime D0=D'01.02.2009';

//+------------------------------------------------------------------+ 
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+ 
int init() 
  { 
//---- indicators 
   SetIndexStyle(0, DRAW_NONE, STYLE_SOLID, 2); 
   SetIndexBuffer(0, TrendUp); 
   SetIndexLabel(0, "TrendUP");
   SetIndexStyle(1, DRAW_NONE, STYLE_SOLID, 2); 
   SetIndexBuffer(1, TrendDown); 
   SetIndexLabel(1, "TrendDOWN");
    
   SetIndexStyle(2, DRAW_LINE, STYLE_DOT); 
   SetIndexBuffer(2, ChannelUp); 
   SetIndexLabel(2, "ChannelUP");
   SetIndexStyle(3, DRAW_LINE, STYLE_DOT); 
   SetIndexBuffer(3, ChannelDown); 
   SetIndexLabel(3, "ChannelDOWN");

   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4, Arrow);   
   SetIndexEmptyValue(4, 0.0); 

   SetIndexStyle(5,DRAW_ARROW);
   SetIndexArrow(5,159);
   SetIndexBuffer(5, ArrowUp);      
   SetIndexEmptyValue(5, 0.0); 

   SetIndexStyle(6,DRAW_ARROW);
   SetIndexArrow(6,159);
   SetIndexBuffer(6, ArrowDn);   
   SetIndexEmptyValue(6, 0.0); 
   
//---- 
   return(0); 
  } 
//+------------------------------------------------------------------+ 
//| Custor indicator deinitialization function                       | 
//+------------------------------------------------------------------+ 
int deinit() 
  { 
//---- 
   return(0); 
  } 
//+------------------------------------------------------------------+ 
//| Custom indicator iteration function                              | 
//+------------------------------------------------------------------+ 
int start() 
  { 
    
   int limit, i, counter; 
   double Range, AvgRange, cciTrendNow, cciTrendPrevious, var; 

   int counted_bars = IndicatorCounted(); 
//---- check for possible errors 
   if(counted_bars < 0) return(-1); 
//---- last counted bar will be recounted 
   if(counted_bars > 0) counted_bars--; 

   limit=Bars-counted_bars; 
    
   for(i = limit; i >= 0; i--) { 
      cciTrendNow = iCCI(NULL, 0, 50, PRICE_TYPICAL, i); 
      cciTrendPrevious = iCCI(NULL, 0, 50, PRICE_TYPICAL, i+1); 
      
      //st = st * 100; 
      
      
      counter = i; 
      Range = 0; 
      AvgRange = 0; 
      for (counter = i; counter >= i-9; counter--) { 
         AvgRange = AvgRange + MathAbs(High[counter]-Low[counter]); 
      } 
      Range = AvgRange/10; 
      if (cciTrendNow >= st && cciTrendPrevious < st) { 
         TrendUp[i+1] = TrendDown[i+1]; 
      } 
      
      if (cciTrendNow <= st && cciTrendPrevious > st) { 
         TrendDown[i+1] = TrendUp[i+1]; 
      } 
      
      if (cciTrendNow >= st) { 
         TrendUp[i] = Low[i] - iATR(NULL, 0, 5, i);          
         if (TrendUp[i] < TrendUp[i+1]) { 
            TrendUp[i] = TrendUp[i+1]; 
         } 
      } 
      else if (cciTrendNow <= st) { 
         TrendDown[i] = High[i] + iATR(NULL, 0, 5, i); 
         if (TrendDown[i] > TrendDown[i+1]) { 
            TrendDown[i] = TrendDown[i+1]; 
         } 
      }
      
      //       
      if (drawChannels) {
         double s0 = Dev*iStdDev(NULL,0,DevPeriod,0,MODE_SMA,PRICE_OPEN,i);
         if (TrendDown[i]==EMPTY_VALUE) {
            if (TrendUp[i+1]==TrendUp[i] && constantChannel) {
               ChannelUp[i] = ChannelUp[i+1]; 
               ChannelDown[i] = ChannelDown[i+1]; 
            } else {          
               ChannelUp[i] = TrendUp[i]+s0; 
               ChannelDown[i] = TrendUp[i]-s0; 
            }
         }
         if (TrendUp[i]==EMPTY_VALUE) {
            if (TrendDown[i+1]==TrendDown[i] && constantChannel) {
               ChannelUp[i] = ChannelUp[i+1]; 
               ChannelDown[i] = ChannelDown[i+1]; 
            } else {          
               ChannelUp[i] = TrendDown[i]+s0; 
               ChannelDown[i] = TrendDown[i]-s0; 
            }
         }
      }
   } 
   int Nstat=iBarShift(NULL,0,D0);

   static int dir = 0;
   static double h0,l0;
   
   // 
   if (Close[Nstat+10]<=Close[Nstat+1]) {
      l0=Close[Nstat+10];
      h0=Close[Nstat+1];
      dir=1;
   }
   if (Close[Nstat+10]>Close[Nstat+1]) {
      l0=Close[Nstat+1];
      h0=Close[Nstat+10];
      dir=-1;
   }
   
   for(i = Nstat; i >= 0; i--) { 
   
      //
      //   
      //   buy
      double Trend;
      if (TrendUp[i]==EMPTY_VALUE) {
         Trend=TrendDown[i];
      } else {
         Trend=TrendUp[i];
      }
      
      if (dir>0&&i<Nstat&&Trend>0) { 
        double rev0=h0*(1-coeff)+l0*coeff; // 
        if (Trend<rev0) { //    coeff - 
           dir = -1;
           l0 = Trend;
        }
        if (Trend>h0) { // 
           h0=Trend;
        }
      }
      //   
      if (dir<0&&i<Nstat&&Trend>0) { //   sell
        double rev1=l0*(1-coeff)+h0*coeff; // 
        if (Trend>rev1) { //    coeff - 
           dir = 1;
           h0 = Trend;
        }
        if (Trend<l0) { // 
           l0=Trend;
        }
      }
      // 
      if (dir>0) {       
         ArrowUp[i]=Trend;
         ArrowDn[i]=0;
      } else {
         ArrowDn[i]=Trend;
         ArrowUp[i]=0;
      }
      Arrow[i]=Trend;
   }
       
//---- 
    
//---- 
   return(0); 
  } 
//+------------------------------------------------------------------+